import java.io.File;
import java.io.IOException;
import java.util.Arrays;
import java.util.TreeSet;

import mgui.io.util.IoFunctions;
import minc.MincFunctions;


public class Temp6 {

	// Cross-check an images directory with a results directory; for all subjects not in results,
	// transfer to a source directory for processing... needed because of job failures 
	public static void main(String[] args){
		
		File results_folder = new File("/export02/data/adni_civet_output_flipped");
		File source_folder = new File("/export02/data/adni_civet_input_15T_024_to_053");
		File images_folder = new File("/export02/data/adni_minc_15T_flipped");
		String stop_at = "023_S_1126_S23441";
		
		String[] results_subjects = results_folder.list(IoFunctions.getDirFilter());
		String[] images_subjects = images_folder.list(MincFunctions.getMincFilter());
		
		Arrays.sort(results_subjects);
		Arrays.sort(images_subjects);
		
		TreeSet<String> result_set = new TreeSet<String>();
		for (int i = 0; i < results_subjects.length; i++)
			result_set.add(results_subjects[i]);
		
		int copied = 0, skipped = 0, failed = 0;
		for (int i = 0; i < images_subjects.length; i++){
			String image = images_subjects[i];
			String subject = image.substring(5, image.indexOf("_t1"));
			if (subject.equals(stop_at)) break;
			if (!result_set.contains(subject)){
				System.out.println("Copying '" + subject + "'.");
				File image_in = new File(images_folder.getAbsolutePath() + File.separator + image);
				File image_out = new File(source_folder.getAbsolutePath() + File.separator + image);
				try{
					IoFunctions.copyFile(image_in, image_out);
				}catch (IOException e){
					e.printStackTrace();
					failed++;
					}
				copied++;
			}else{
				skipped++;
				}
			}
		
		System.out.println("Done. " + copied + " copied. " + skipped + " skipped. " + failed + " failed.");
		
	}
	
	
}
