import java.io.File;
import java.util.ArrayList;

import javax.vecmath.Point3f;

import mgui.geometry.Mesh3D;
import mgui.interfaces.shapes.Mesh3DInt;
import mgui.io.foreign.minc.MincSurfaceDataWriter;
import mgui.io.foreign.minc.MincSurfaceLoader;
import mgui.numbers.MguiDouble;
import mgui.numbers.MguiNumber;


public class Temp7 {

	
	public static void main(String[] args){
		
		File surface = new File("/export02/data/civet/surf_reg_model.obj");
		File x_out = new File("/export02/data/mgui/surf_reg_x.txt");
		File y_out = new File("/export02/data/mgui/surf_reg_y.txt");
		File z_out = new File("/export02/data/mgui/surf_reg_z.txt");
		MincSurfaceLoader loader = new MincSurfaceLoader(surface);
		
		try{
			Mesh3DInt mesh_int = loader.loadSurface();
			Mesh3D mesh = mesh_int.getMesh();
			
			ArrayList<MguiNumber> x_list = new ArrayList<MguiNumber>(mesh.getVertexCount());
			ArrayList<MguiNumber> y_list = new ArrayList<MguiNumber>(mesh.getVertexCount());
			ArrayList<MguiNumber> z_list = new ArrayList<MguiNumber>(mesh.getVertexCount());
		
			ArrayList<Point3f> vertices = mesh.getVertices();
			
			for (int i = 0; i < vertices.size(); i++){
				Point3f p = vertices.get(i);
				x_list.add(new MguiDouble(p.x));
				y_list.add(new MguiDouble(p.y));
				z_list.add(new MguiDouble(p.z));
				}
			
			MincSurfaceDataWriter writer = new MincSurfaceDataWriter(x_out);
			writer.writeValues(x_list);
			writer = new MincSurfaceDataWriter(y_out);
			writer.writeValues(y_list);
			writer = new MincSurfaceDataWriter(z_out);
			writer.writeValues(z_list);
		
			System.out.println("Done.");
			
		}catch (Exception e){
			e.printStackTrace();
		}
	}
	
}
