package mgui.security;

import java.nio.ByteBuffer;
import java.nio.charset.Charset;
import java.security.spec.KeySpec;
import java.util.Arrays;

import javax.crypto.Cipher;
import javax.crypto.SecretKey;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.DESKeySpec;

import mgui.command.CommandInstance;
import mgui.datasources.security.SecureDataSourceFunctions;

import org.apache.commons.codec.binary.Base64;

public class SecurityTests extends CommandInstance {

	
	public static void main(String[] args) throws Exception{
		SecurityTests instance = new SecurityTests();
		instance.execute(args);
	}
	
	@Override
	protected boolean run_command(String command) {
		
		if (command.equals("get_system_encrypted_string")){
			return print_system_encrypted_string();
			}
		
		if (command.equals("wtf_linux")){
			return wtf_linux();
			}
		
		return false;
	}
	
	boolean print_system_encrypted_string(){
		
		String plaintext = parameters.get("plaintext");
		
		try{
			String encrypt = SecureDataSourceFunctions.getEncryptedPassword(plaintext);
			System.out.println("String '" + plaintext + "' encrypts to '" +
					encrypt + "'.");
			SecureDataSourceFunctions.getSecureConnection("", "", encrypt);
			return true;
		}catch (Exception e){
			e.printStackTrace();
		}
		
		return false;
		
	}
	
	boolean wtf_linux(){
		
		SecretKeyFactory	keyFactory;
		//byte[] keyAsBytes = ("j5^&l:2sp[ku}t99*~vw-~;ld>/x+Ak$$r0Fl.1olQ#84M_%").getBytes();
		
		byte[] keyAsBytes = ("j5^&l:2sp[ku}t99*~vw-~;ld>/x+Ak$$r0Fl.1olQ#84M_%").getBytes();
		
		try{
			
			KeySpec				keySpec = new DESKeySpec( keyAsBytes );
			keyFactory = SecretKeyFactory.getInstance( "DES" );
			SecretKey key = keyFactory .generateSecret( keySpec );
			Cipher e_cipher = Cipher.getInstance( "DES" ),
				   d_cipher = Cipher.getInstance( "DES" );
			
			//ENCRYPT
			
			//PASSWORD IN
			String text = "aFrit0$a";
			System.out.println("Password in string: " + text);
			Charset charset = Charset.forName("ISO-8859-1");
			
			//PASSWORD AS BYTES
			byte[] password = charset.encode(text).array();
			System.out.println("Password in bytes: " + Arrays.toString(password));
			
			e_cipher.init( Cipher.ENCRYPT_MODE, key );
			
			//PASSWORD ENCRYPTED
			byte[] cipher = e_cipher.doFinal(password);
			Base64 base64 = new Base64(72,new byte[]{});
			System.out.println("Cipher bytes: " + Arrays.toString(cipher));
			
			//NATIVE BYTES ENCODED IN BASE64
			byte[] encoded64 = base64.encode(cipher);
			
			System.out.println("Cipher base64 bytes: " + Arrays.toString(encoded64));
			
			//BASE64 BYTES AS STRING
			String cipher_string = charset.decode(ByteBuffer.wrap(encoded64)).toString();
			
			System.out.println("Cipher base64 string: " + cipher_string);
			
			// DECRYPT
			
			//ENCRYPTED PASSWORD AS BYTES
			byte[] cipher_decode = charset.encode(cipher_string).array();
			
			System.out.println("Cipher base64 bytes: " + Arrays.toString(cipher_decode));
			
			//BASE64 BYTES DECODED TO NATIVE
			byte[] decoded64 = base64.decode(cipher_decode);
			
			System.out.println("Cipher decoded bytes: " + Arrays.toString(decoded64));
						
			key = keyFactory .generateSecret( keySpec );
			d_cipher.init( Cipher.DECRYPT_MODE, key );
			
			//ENCRYPTED BYTES DECRYPTED
			byte[] decrypt = d_cipher.doFinal(decoded64);
						
			System.out.println("Password decrypted bytes: " + Arrays.toString(decrypt));
			
			//DECRYPTED BYTES AS STRING
			String decrypted = new String(charset.decode(ByteBuffer.wrap(decrypt)).array());
			System.out.println("Password decrypted string: " +decrypted);
			
			return true;
			
		
		}catch (Exception e){
			e.printStackTrace();
			}
		return false;
	}
	

}
